<?php
class SMSSender{
  private $login;
  private $pass;
  private $api = "https://smsgateapi.sms-sluzba.cz/apixml30/";
  private $dorucenka = 1;
  
  public $error_text="";
  public $error_status="";
  
  public function __construct($login, $pass, $api = false){
    $this->login = $login;
    $this->pass = $pass;
    if($api){
      $this->api = $api;
    }
  }
  
  private function setLoginInfo(){
    return "?login=".$this->login."&password=".$this->pass;
  }
  
  private function resetError(){
    $this->error_text = "Žádná zjištěná chyba";
    $this->error_status = "000";
  }
  
  private function addError($status, $text){
    $this->error_text = $text;
    $this->error_status = $status;
  }
  
  private function send_GET($api_type, $query_array=array()){
    $this->resetError();
    
    $query_data="";
    if(!empty($query_array)){
      $query_data="&".http_build_query($query_array);
    }
    
    $ch = curl_init();
    
    curl_setopt($ch, CURLOPT_URL, $this->api.$api_type.$this->setLoginInfo().$query_data);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    
    $data = curl_exec($ch);
    curl_close($ch);
    
    if(empty($data)){
      $this->addError("999", "Neznámá GET chyba");
      
      return false;
    }
    
    $xml = simplexml_load_string($data);
    if($xml->getName() == "status"){
      $this->addError((string)$xml->id, (string)$xml->message);
      return false;
    }
    
    return $xml;
  }
  
  private function send_POST($api_type, $post_data){
    $this->resetError();
    
    $ch = curl_init();
    
    curl_setopt($ch, CURLOPT_URL, $this->api.$api_type.$this->setLoginInfo());
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: text/xml'));
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    
    $data = curl_exec($ch);
    curl_close($ch);
    
    if(empty($data)){
      $this->addError("999", "Neznámá GET chyba");
      
      return false;
    }
    
    $xml = simplexml_load_string($data);
    if($xml->getName() == "status"){
      $this->addError((string)$xml->id, (string)$xml->message);
      return false;
    }
    
    return $xml;
  }
  
  public function sendSMS($komu, $text, $dorucenka=2){
    if($dorucenka == 2){
      $dorucenka = $this->dorucenka;
    }
    if($dorucenka){
      $dorucenka = 20;
    }else{
      $dorucenka = 0;
    };
    
    $dataXML = new SimpleXMLElement("<outgoing_message></outgoing_message>");
    $dataXML->addChild("dr_request", (string)$dorucenka);
    $dataXML->addChild("text", (string)$text);
    $dataXML->addChild("recipient", (string)$komu);
    
    $dataXML = str_replace('version="1.0"', 'version="1.0" encoding="UTF-8"', $dataXML->asXML());
    
    //header("Content-type: text/xml");
    $res = $this->send_POST("receiver", $dataXML);
    if($res)
      return (array)$res->message;
    return false;
  }
  
  public function getDorucenka($id=false){
    if($id==false)
      return false;
    
    $res = $this->send_GET("sender", array("act" => "get_delivery_report", "id" => $id));
    if($res)
      return $res;
      
    return (bool)$res;
  }
  
  public function getAccountInfo(){
    $res = $this->send_GET("info/credit");
    if($res)
      return (array)$res;
      
    return (bool)$res;
  }
}


?>