<?php
/*
* 2017 Ráj eshopu
* autor: Michael Novotný
* last update: 5.2.2017
*/

if (!defined('_PS_VERSION_'))
	exit;

require_once(dirname(__FILE__)."/SMSSender.api.php");

class re_smssluzba extends Module{
    public function __construct()
    {
        $this->name = 're_smssluzba';
        $this->tab = 'emailing';
        $this->version = 1.05;
		    $this->author = 'Ráj Eshopů';
		    $this->need_instance = 0;
        $this->bootstrap = true;

        parent::__construct();
		
        $this->displayName = $this->l('SMS Sender - sms-sluzba.cz');
        $this->description = $this->l('Odesílá levně SMS zákazníkům přes SMS bránu sms-sluzba.cz');
        
        $this->module_url = $this->context->link->getAdminLink("AdminModules", true)."&configure=".$this->name."&module_name=".$this->name;
        $this->api = new SMSSender(Configuration::get("RE_SMSSLUZBA_LOGIN"), Configuration::get("RE_SMSSLUZBA_PASS"));
    }
    
    public function install(){
      if(parent::install() &&
        $this->registerHook("displayAdminOrder") &&
        $this->registerHook("displayBackOfficeHeader") &&
        $this->registerHook("displayBackOfficeTop") &&
        $this->registerHook("actionOrderStatusUpdate") &&
        $this->createTables() &&
        Configuration::updateValue("RE_SMSSLUZBA_FIELD", "phone")
        )
        return true;
      return false;
    }
    
    public function uninstall(){
      if($this->unregisterHook("displayAdminOrder") &&
        $this->unregisterHook("displayBackOfficeHeader") &&
        $this->unregisterHook("displayBackOfficeTop") &&
        $this->unregisterHook("actionOrderStatusUpdate") &&
        $this->removeTable() &&
        Configuration::deleteByName("RE_SMSSLUZBA_FIELD")
        )
        return parent::uninstall();
      return false;
    }
    
    private function createTables(){
      $sql = 'CREATE TABLE `'._DB_PREFIX_.'re_smssluzba_sms` ( `id_sms` INT NOT NULL AUTO_INCREMENT , `name` TEXT NOT NULL , `text` TEXT NOT NULL , `id_order_state` INT NOT NULL , PRIMARY KEY (`id_sms`) ) ENGINE = MyISAM;';
      $sql1 = 'CREATE TABLE `'._DB_PREFIX_.'re_smssluzba_odeslano` ( `id_odeslano` INT NOT NULL AUTO_INCREMENT , `id_order` INT NOT NULL , `id_sms` TEXT NOT NULL , `text` TEXT NOT NULL , `phone` TEXT NOT NULL , `doruceno` INT NOT NULL , `date_add` DATETIME NOT NULL , PRIMARY KEY (`id_odeslano`) ) ENGINE = MyISAM;';
      $sql2 = 'CREATE TABLE `'._DB_PREFIX_.'re_smssluzba_log` ( `id_log` INT NOT NULL AUTO_INCREMENT , `text` TEXT NOT NULL , `precteno` INT NOT NULL , PRIMARY KEY (`id_log`) ) ENGINE = MyISAM;';
      
      return (Db::getInstance()->execute($sql) && Db::getInstance()->execute($sql1) && Db::getInstance()->execute($sql2));
    }
    
    private function removeTable(){
      $sql = 'DROP TABLE `'._DB_PREFIX_.'re_smssluzba_sms`';
      $sql1 = 'DROP TABLE `'._DB_PREFIX_.'re_smssluzba_odeslano`';
      $sql2 = 'DROP TABLE `'._DB_PREFIX_.'re_smssluzba_log`';
      
      return (Db::getInstance()->execute($sql) && Db::getInstance()->execute($sql1) && Db::getInstance()->execute($sql2));
    }
    
    public function addLog($text=false){
      if($text)
        return (bool)Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."re_smssluzba_log` VALUES(NULL, '".date("Y-m-d H:i:s")." - ".$text."', '0')");
      return false;
    }
    
    public function hookdisplayBackOfficeTop(){
      $return = Db::getInstance()->executeS("SELECT * FROM `"._DB_PREFIX_."re_smssluzba_log` WHERE `precteno`='0'");
      if($return){
        $text=$this->l("SMSSLužba Sender").$this->l(" - V logu máte ").count($return).$this->l(" nepřečtených chyb -").'<a href="'.$this->module_url.'&active_tab=log">'.$this->l("Přejít do LOGu").'</a>';
        $output='<script type="text/javascript">
          $(document).ready(function(){
            showErrorMessage(\''.$text.'\', 10000);
          });
        </script>';
        
        return $output;
      }
      return ;
    }
    
    public function getContent(){
      $tab = Tools::getValue("active_tab", "config");
      $this->context->smarty->assign("module_url", $this->module_url);
      $this->context->smarty->assign("module_tab", $tab);
      $this->context->smarty->assign("tpl_smssluzba_nav", dirname(__FILE__)."/views/templates/module_config/");
      
      if($tab == "config"){
        if(Tools::isSubmit("save_api")){
          Configuration::updateValue("RE_SMSSLUZBA_LOGIN", Tools::getValue("smssluzba_login"));
          Configuration::updateValue("RE_SMSSLUZBA_PASS", Tools::getValue("smssluzba_pass"));
          Configuration::updateValue("RE_SMSSLUZBA_FIELD", Tools::getValue("smssluzba_field"));
          
          Tools::redirectAdmin($this->module_url."&active_tab=config&conf=6");
        }
        
        if(Tools::isSubmit("send_test_sms")){
          
          $return = $this->api->sendSMS(Tools::getValue("smssluzba_test_number"), Tools::getValue("smssluzba_test_text"));
          if(!$return){
            $this->addLog($this->l("Testovací SMS se nepodařilo odeslat - text chyby: ").$this->api->error_text);
          }
          
          Tools::redirectAdmin($this->module_url."&active_tab=config");
        }
        $stav = $this->api->getAccountInfo();
        $this->context->smarty->assign("stav", $stav);
        if(!$stav){
          $this->context->smarty->assign("error_text", $this->api->error_text);
        }
        return $this->display(__FILE__, "/views/templates/module_config/config.tpl");
      }elseif($tab == "sms_list"){
        $sms = Db::getInstance()->executeS("SELECT a.*,b.`name` AS `status` FROM `"._DB_PREFIX_."re_smssluzba_sms` a LEFT JOIN `"._DB_PREFIX_."order_state_lang` b ON(a.`id_order_state`=b.`id_order_state` AND b.`id_lang`='".$this->context->cookie->id_lang."') WHERE 1 ORDER BY a.`id_sms` ASC");
        $this->context->smarty->assign("smsky", $sms);
        
        $sms_json = array();
        if($sms){
          foreach($sms as $smska){
            $sms_json[(int)$smska["id_sms"]]=$smska;
          }
        }
        
        $this->context->smarty->assign("smsky_json", $sms_json);
        if(Tools::isSubmit("delete_sms")){
          Db::getInstance()->execute("DELETE FROM `"._DB_PREFIX_."re_smssluzba_sms` WHERE `id_sms`='".Tools::getValue("delete_sms", 0)."'");
          Tools::redirectAdmin($this->module_url."&active_tab=sms_list&conf=1");
        }
        
        if(Tools::isSubmit("save_add")){
          $sluzba_name = Tools::getValue("smssluzba_name");
          $sluzba_text = Tools::getValue("smssluzba_text");
          if(empty($sluzba_name) OR empty($sluzba_text)){
            Tools::redirectAdmin($this->module_url."&active_tab=sms_list&smssluzba_error=1");
          }
          Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."re_smssluzba_sms` VALUES(NULL, '".Tools::getValue("smssluzba_name", "")."', '".Tools::getValue("smssluzba_text", "")."', '".Tools::getValue("smssluzba_id_order_state", 0)."')");
          Tools::redirectAdmin($this->module_url."&active_tab=sms_list&conf=3");
        }
        
        if(Tools::isSubmit("save_edit")){
          $sluzba_name = Tools::getValue("smssluzba_name");
          $sluzba_text = Tools::getValue("smssluzba_text");
          if(empty($sluzba_name) OR empty($sluzba_text)){
            Tools::redirectAdmin($this->module_url."&active_tab=sms_list&smssluzba_error=1");
          }
          Db::getInstance()->execute("UPDATE `"._DB_PREFIX_."re_smssluzba_sms` SET `name`='".Tools::getValue("smssluzba_name", "")."',`text`='".Tools::getValue("smssluzba_text", "")."',`id_order_state`='".Tools::getValue("smssluzba_id_order_state", 0)."' WHERE `id_sms`='".Tools::getValue("id_sms")."'");
          Tools::redirectAdmin($this->module_url."&active_tab=sms_list&conf=4");
        }
        
        $stavy = Db::getInstance()->executeS("SELECT a.`id_order_state`,b.`name` FROM `"._DB_PREFIX_."order_state` a LEFT JOIN `"._DB_PREFIX_."order_state_lang` b ON (a.`id_order_state`=b.`id_order_state`) WHERE b.`id_lang`='".$this->context->cookie->id_lang."' AND a.`deleted`='0'");
        $this->context->smarty->assign("stavy", $stavy);
        return $this->display(__FILE__, "/views/templates/module_config/sms_list.tpl");
      }elseif($tab == "log"){
        if(Tools::isSubmit("oznacit_prectene")){
          Db::getInstance()->execute("UPDATE `"._DB_PREFIX_."re_smssluzba_log` SET `precteno`='1' WHERE `precteno`='0'");
          Tools::redirectAdmin($this->module_url."&active_tab=log&conf=5");
        }
        $logs = Db::getInstance()->executeS("SELECT * FROM `"._DB_PREFIX_."re_smssluzba_log` WHERE `precteno`='0' ORDER BY `id_log` DESC");
        $this->context->smarty->assign("logy", $logs);
        return $this->display(__FILE__, "/views/templates/module_config/log.tpl");
      }elseif($tab == "dorucenky"){
        $this->getDorucenky();
        Tools::redirectAdmin($this->module_url."&active_tab=config&conf=5");
      }
      return $this->l("Neexistuje požadovaná podstránka");
    }
    
    public function hookdisplayAdminOrder($params){
      $id_order = $params["id_order"];
      $order_url = $this->context->link->getAdminLink("AdminOrders", true)."&id_order=".$id_order."&vieworder";
      $this->context->smarty->assign("order_url", $order_url);
      
      if(Tools::isSubmit("send_sms")){
        $text = Tools::getValue("smssluzba_text");
        if($text == "")
          Tools::redirectAdmin($order_url);
        
        $o = new Order($id_order);
        $a = new Address($o->id_address_delivery);
        $field = Configuration::get("RE_SMSSLUZBA_FIELD");
        $telefon = false;
        
        if($field == "phone"){
          if(!empty($a->phone)){
            $telefon = $a->phone;
          }elseif(!empty($a->phone_mobile)){
            $telefon = $a->phone_mobile;
          }
        }elseif($field == "phone_mobile"){
          if(!empty($a->phone_mobile)){
            $telefon = $a->phone_mobile;
          }elseif(!empty($a->phone)){
            $telefon = $a->phone;
          }
        }
        
        if(!$telefon)
          Tools::redirectAdmin($order_url);
        
        $return = $this->api->sendSMS($telefon, $text);
        if($return){
          Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."re_smssluzba_odeslano` VALUES(NULL, '".$id_order."', '".$return["id"]."', '".$text."', '".$return["recipient"]."', '0', '".date("Y-m-d H:i:s")."')");
          Tools::redirectAdmin($order_url);
        }else{
          $this->addLog($this->l("U objednávky ID:").$id_order.$this->l(" se nepodařilo odeslat SMS - text chyby: ").$this->api->error_text);
          Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."re_smssluzba_odeslano` VALUES(NULL, '".$id_order."', '0', '".$text."', '".$telefon."', '2', '".date("Y-m-d H:i:s")."')");
          Tools::redirectAdmin($order_url);
        }
      }
      
      $sms = Db::getInstance()->executeS("SELECT a.*,b.`name` AS `status` FROM `"._DB_PREFIX_."re_smssluzba_sms` a LEFT JOIN `"._DB_PREFIX_."order_state_lang` b ON(a.`id_order_state`=b.`id_order_state` AND b.`id_lang`='".$this->context->cookie->id_lang."') WHERE 1 ORDER BY a.`id_sms` ASC");
      $this->context->smarty->assign("smsky", $sms);
        
      $sms_json = array();
      if($sms){
        foreach($sms as $smska){
          $smska["text"]=$this->getPromenneSMS($smska["text"], $id_order);
          $sms_json[(int)$smska["id_sms"]]=$smska;
        }
      }
        
      $this->context->smarty->assign("smsky_json", $sms_json);
      
      $odeslane_sms = Db::getInstance()->executeS("SELECT * FROM `"._DB_PREFIX_."re_smssluzba_odeslano` WHERE `id_order`='".$id_order."' ORDER BY `id_odeslano` DESC");
      
      $this->context->smarty->assign("odeslane_sms", $odeslane_sms);
      $this->context->smarty->assign("sms_info", $this->api->getAccountInfo());
      return $this->display(__FILE__, "/views/templates/order.tpl");
    }
    
    public function getPromenneSMS($text, $id_order = false){
      $o = new Order($id_order);
      $a = new Address($o->id_address_delivery);
      $c = new Customer($o->id_customer);
      $car = new Carrier($o->id_carrier);
      
      $repl = array(
       "%CISLOOBJEDNAVKY%" => $o->reference,
       "%ID_OBJEDNAVKY%" => $o->id,
       "%JMENO%" => $c->firstname,
       "%PRIJMENI%" => $c->lastname,
       "%CELKOVA_CENA%" => Tools::displayPrice($o->total_paid_tax_incl, (int)$o->id_currency),
       "%EMAIL%" => $c->email,
       "%DATUM_OBJEDNAVKY%" => $o->date_add,
       "%DOPRAVCE%" => $car->name,
      );

      foreach($repl as $key => $val){
        $text = str_replace($key, $val, $text);
      }
      
      return $text;
    }
    
    public function hookactionOrderStatusUpdate($params){
      $id_order = $params["id_order"];
      $state = $params["newOrderStatus"];
      
      $o = new Order($id_order);
      $a = new Address($o->id_address_delivery);
      $field = Configuration::get("RE_SMSSLUZBA_FIELD");
      $telefon = false;
      
      if($field == "phone"){
        if(!empty($a->phone)){
          $telefon = $a->phone;
        }elseif(!empty($a->phone_mobile)){
          $telefon = $a->phone_mobile;
        }
      }elseif($field == "phone_mobile"){
        if(!empty($a->phone_mobile)){
          $telefon = $a->phone_mobile;
        }elseif(!empty($a->phone)){
          $telefon = $a->phone;
        }
      }
      
      if(!$telefon){
        $this->addLog($this->l("U objednávky ID:").$id_order.$this->l(" se nepodařilo odeslat SMS - text chyby: ").$this->l("nepodařilo se získat tel. číslo"));
        return true;
      }
      
      $s = Db::getInstance()->executeS("SELECT * FROM `"._DB_PREFIX_."re_smssluzba_sms` WHERE `id_order_state`='".$state->id."'");
      if($s){
        foreach($s as $sms){
          $text = $sms["text"];
          $text = $this->getPromenneSMS($text, $id_order);
          
          $return = $this->api->sendSMS($telefon, $text);
          if($return){
            Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."re_smssluzba_odeslano` VALUES(NULL, '".$id_order."', '".$return["id"]."', '".$text."', '".$return["recipient"]."', '0', '".date("Y-m-d H:i:s")."')");
          }else{
            $this->addLog($this->l("U objednávky ID:").$id_order.$this->l(" se nepodařilo odeslat SMS - text chyby: ").$this->api->error_text);
            Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."re_smssluzba_odeslano` VALUES(NULL, '".$id_order."', '0', '".$text."', '".$telefon."', '2', '".date("Y-m-d H:i:s")."')");
          }
          
        }
      }else{
        return true;
      }
      
      return true;
    }
    
    public function getDorucenky(){
      $s = Db::getInstance()->executeS("SELECT * FROM `"._DB_PREFIX_."re_smssluzba_odeslano` WHERE `doruceno`='0'");
      if($s){
        foreach($s as $sms){
          $id_sms = $sms["id_sms"];
          $r = $this->api->getDorucenka($id_sms);
          if($r){
            if((int)$r->message->status == 0){
              Db::getInstance()->execute("UPDATE `"._DB_PREFIX_."re_smssluzba_odeslano` SET `doruceno`='1' WHERE `id_odeslano`='".$sms["id_odeslano"]."'");
            }
          }
        }
      }
    }
}
?>